Attribute VB_Name = "modMain"
Option Explicit

'_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
'                                 modCapture
'_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

Private Declare Sub CopyMemory _
                Lib "kernel32" _
                Alias "RtlMoveMemory" (lpDest As Any, _
                                       lpSource As Any, _
                                       ByVal cBytes As Long)

Private Declare Function GetModuleHandle _
                Lib "kernel32" _
                Alias "GetModuleHandleA" (ByVal lpModuleName As String) As Long

Private Declare Function GetProcAddressNum _
                Lib "kernel32" _
                Alias "GetProcAddress" (ByVal hModule As Long, _
                                        ByVal lpProcName As Long) As Long

Private Declare Function GetProcAddress _
                Lib "kernel32" (ByVal hModule As Long, _
                                ByVal lpProcName As String) As Long

Private Const PROCESS_ALL_ACCESS As Long = &H1F0FFF

Private Declare Function OpenProcess _
                Lib "kernel32" (ByVal dwDesiredAccess As Long, _
                                ByVal bInheritHandle As Long, _
                                ByVal dwProcessId As Long) As Long

'Private Declare Function GetWindowThreadProcessId _
'                Lib "user32" (ByVal hwnd As Long, _
'                              lpdwProcessId As Long) As Long

Private Declare Function GetCurrentProcessId _
                Lib "kernel32" () As Long

Private Declare Function ReadProcessMemory _
                Lib "kernel32" (ByVal hProcess As Long, _
                                lpBaseAddress As Any, _
                                lpBuffer As Any, _
                                ByVal nSize As Long, _
                                lpNumberOfBytesWritten As Long) As Long

Private Declare Function WriteProcessMemory _
                Lib "kernel32" (ByVal hProcess As Long, _
                                lpBaseAddress As Any, _
                                lpBuffer As Any, _
                                ByVal nSize As Long, _
                                lpNumberOfBytesWritten As Long) As Long

Private Declare Function ReadFile _
                Lib "kernel32" (ByVal hFile As Long, _
                                lpBuffer As Any, _
                                ByVal nNumberOfBytesToRead As Long, _
                                lpNumberOfBytesRead As Long, _
                                ByVal lpOverlapped As Any) As Long

Private sReadFile As String '

Private MyAdrReadFile As Long '  

Private ApAdrReadFile As Long '  

Private Declare Function CloseHandle _
                Lib "kernel32" (ByVal hObject As Long) As Long

Private Declare Function LoadLibrary _
                Lib "kernel32" _
                Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long

'Private LstOpen As Boolean

'_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
'                                 modSafeArray
'_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
Private Type SAFEARRAYBOUND ' 8 bytes
    cElements As Long
    lLbound   As Long
End Type

Public Type SAFEARRAYHEADER ' 20 bytes (for one dimensional arrays
    dimensions    As Integer
    fFeatures     As Integer
    DataSize      As Long
    cLocks        As Long
    dataPointer   As Long
    sab(0)        As SAFEARRAYBOUND
End Type

'Private Const FADF_AUTO = &H1&        '// Array is allocated on the stack.
'Private Const FADF_STATIC = &H2&      '// Array is statically allocated.
'Private Const FADF_EMBEDDED = &H4&    '// Array is embedded in a structure.
'Private Const FADF_FIXEDSIZE = &H10&  '// Array may not be resized or reallocated.
'Private Const FADF_BSTR = &H100&      '// An array of BSTRs.
'Private Const FADF_UNKNOWN = &H200&   '// An array of IUnknown*.
'Private Const FADF_DISPATCH = &H400&  '// An array of IDispatch*.
'Private Const FADF_VARIANT = &H800&   '// An array of VARIANTs.
'Private Const FADF_RESERVED = &HF0E8& '// Bits reserved for future use.

Public Enum eDATASIZE
    byteArray = 1
    integerArray = 2  ' or Boolean Data Type
    longArray = 4
    singleArray = 4
    doubleArray = 8
End Enum

Private Declare Sub RtlMoveMemory _
                Lib "kernel32.dll" (dest As Any, _
                                    src As Any, _
                                    ByVal cb As Long)

Public Declare Function VarPtrArray _
               Lib "msvbvm50.dll" _
               Alias "VarPtr" (Var() As Any) As Long

Public Declare Function ArrPtr _
               Lib "msvbvm60" _
               Alias "VarPtr" (arr() As Any) As Long

Private Declare Sub SafeArrayAllocDescriptor _
                Lib "oleaut32.dll" (ByVal cDims As Long, _
                                    ppsaOut As Any)

Private Declare Sub SafeArrayDestroyDescriptor _
                Lib "oleaut32.dll" (psa As Any)

' 4   src  dest.  0.
Private Declare Function GetMem4 _
                Lib "msvbvm60" (ByVal ptrToLongSrc As Long, _
                                ByVal ptrToLongDest As Long) As Long

' 4   dest.  0.
Private Declare Function PutMem4 _
                Lib "msvbvm60" (ByVal ptrToLongDest As Long, _
                                ByVal NewValue As Long) As Long

'_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
'                                 modCapture
'_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
'         
'   ReadFile
Public Sub CaptureLib()
    Dim pId As Long
    Dim pHandle As Long '
    '  
    '    GetWindowThreadProcessId frmMain.hwnd, pId
    pId = GetCurrentProcessId
    '  
    pHandle = OpenProcess(PROCESS_ALL_ACCESS, False, pId)
    '  
    MyAdrReadFile = GetAdres(AddressOf MyReadFile)
    '  
    ApAdrReadFile = IsFunctionExported("ReadFile", "kernel32")
    sReadFile = StartSpy(pHandle, ApAdrReadFile, MyAdrReadFile)
    
    CloseHandle pHandle
    '    LstOpen = False
End Sub

' 
'ProcessId -  
'ApFunctionAdr -   
'MyFunctionAdr -   
'    6   
'Ex: StartSpy(pId, "kernel32", "ReadFile", mAdr)
Private Function StartSpy(pHandle As Long, _
                          ApFunctionAdr As Long, _
                          MyFunctionAdr As Long) As String
    Dim TmpStr As String * 6
    Dim buf(0 To 5) As Byte '
    Dim jmp(0 To 5) As Byte
    Dim i As Long
    
    jmp(0) = &H68 '    push
    CopyMemory jmp(1), MyFunctionAdr, 4 ' push
    jmp(5) = &HC3 '    ret
    '     6   API 
    ReadProcessMemory pHandle, ByVal ApFunctionAdr, buf(0), 6, 0&
    WriteProcessMemory pHandle, ByVal ApFunctionAdr, jmp(0), 6, 0&
    
    '   
    For i = 0 To 5
        Mid$(TmpStr, i + 1, 1) = Chr$(buf(i))
    Next

    StartSpy = TmpStr
End Function

' 
'ProcessId -  
'ApFunctionAdr -   
'OldCod -    6   
Private Sub StopSpy(pHandle As Long, _
                    ApFunctionAdr As Long, _
                    OldCod As String)
    Dim buf(0 To 5) As Byte '
    Dim i As Long

    '   
    For i = 0 To 5
        buf(i) = Asc(Mid$(OldCod, i + 1, 1))
    Next

    WriteProcessMemory pHandle, ByVal ApFunctionAdr, buf(0), 6, 0&
End Sub

Private Function GetAdres(Ptr As Long) As Long
    GetAdres = Ptr
End Function

Private Function IsFunctionExported(ByVal sFunction As String, _
                                    ByVal sModule As String) As Long
    Dim hMod As Long
    ' 
    hMod = GetModuleHandle(sModule)

    If hMod = 0 Then '
        hMod = LoadLibrary(sModule)
    End If

    If hMod Then
        If IsNumeric(sFunction) = True Then
            Dim mNum As Long
            mNum = MakeDWord(CInt(sFunction), 0)
            IsFunctionExported = GetProcAddressNum(hMod, mNum)
        Else
        
            IsFunctionExported = GetProcAddress(hMod, sFunction)
        End If
    End If

End Function

Private Function MyReadFile(ByVal hFile As Long, _
                            ByVal lpBuffer As Long, _
                            ByVal nNumberOfBytesToRead As Long, _
                            ByVal lpNumberOfBytesRead As Long, _
                            ByVal lpOverlapped As Long) As Long
    Dim KeyHex As String
    Dim pId As Long
    Dim pHandle As Long
    Dim b() As Byte
    '   ,   
    KeyHex = "BD817D23177BB739BFFA0FF295B3764545EF2166BD32978FE41B08FF898A" & _
       "DF4399079CB49662DC414497BA6FA5F45B9D297FC38D1E92ED206DC91C61" & _
       "881E6CC59E52ACB1138E703E2C4A61380E6ED86CE9B7AB23715D48E98EF2" & _
       "FF94548EA4823529562275489AB6DFDCAC57B6671639EF6081309DD9CB73" & _
       "AD5F5BA0D322B102C456420EA6D88233C51542D287283D8CA242ECBC8C4F" & _
       "A24534D6D68EEF22BBCAB59E177D8D86523C46BCCCB468F773ED6A2595D0" & _
       "2607F3E7892019658FD4E9666ECC7E7812992F59CA9BF1034121E3E5AFCF" & _
       "24745048E7E21605CA2E9A84655C59A71E061D5B4414B9785AC6F9E8B3FB" & _
       "D90C40AEF55BA6BD414D94EEFA775435DCF69F2F9613B6F17B1CAE087A98" & _
       "0CB850A19188FC88581074BF1EB196F5DF776183ABFB6508AF7C784F96CE" & _
       "AB7815A27D57C0094E18233416250F7E564931AC4F15E7737282583B19D8" & _
       "BA2274CFF644C6F5753AD05032E08E450F5B22B76E5B0E72FE9EA6CAD6B5" & _
       "C481C10CBDE7D923944558216E7BAA8C46E7C652E289BF0D06659684E72A" & _
       "5375E21154916E07E4C8500D10C80EDFB5C0A5D4DE6A7E084E499FB5582E" & _
       "1FE5F610DB4E1ABD6F7540BD6016453797C57B0614D5FCACDE794097412A" & _
       "EBA33448E8E01904BC96A87C14872E28A074F27524E2F8B0CB1FEA27BF7F" & _
       "548BF7EB1097529DFFF6E125026388B0210BC8890837D6E0BC2FF1CA8B59" & _
       "F38A"
    '  
    '    GetWindowThreadProcessId frmMain.hwnd, pId
    pId = GetCurrentProcessId
    pHandle = OpenProcess(PROCESS_ALL_ACCESS, False, pId)
    Call StopSpy(pHandle, ApAdrReadFile, sReadFile)
    MyReadFile = ReadFile(hFile, ByVal lpBuffer, nNumberOfBytesToRead, ByVal lpNumberOfBytesRead, ByVal lpOverlapped)
    
    CreateSAFEARRAY ArrPtr(b), 1, lpBuffer, 0, nNumberOfBytesToRead - 1
    Dim EncryptRC4 As New clsRC4
    EncryptRC4.DecryptByte b(), HexDecode(KeyHex)
    DestroySAFEARRAY ArrPtr(b)
    
    '    If LstOpen = False Then
    '    '  Access 97   
    '        LstOpen = True
    '        sReadFile = StartSpy(pHandle, ApAdrReadFile, MyAdrReadFile)
    '    End If
    CloseHandle pHandle
End Function

Private Function MakeDWord(LoWord As Integer, _
                           HiWord As Integer) As Long
    ' by Donald, donald@xbeat.net, 20001205
    CopyMemory MakeDWord, LoWord, 2&
    CopyMemory ByVal VarPtr(MakeDWord) + 2&, HiWord, 2&
End Function

'_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
'                                 modSafeArray
'_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

Public Function CreateSAFEARRAY(ByVal ppBlankArr As Long, _
                                ByVal ElemSize As Long, _
                                ByVal pData As Long, _
                                ParamArray Bounds()) As Long
    Dim p As Long, i As Long
  
    'ParamArray Bounds -    :
    'bounds(0) -    
    'bounds(1) -    
    'bounds(2) -    
    'bounds(3) -      ..
  
    SafeArrayAllocDescriptor (UBound(Bounds) + 1) / 2, ByVal ppBlankArr
  
    GetMem4 ppBlankArr, VarPtr(p)
    PutMem4 p + 4, ElemSize
    PutMem4 p + 12, pData
  
    For i = 0 To UBound(Bounds) Step 2
        PutMem4 p + 16 + i * 4, Bounds(i + 1) - Bounds(i) + 1
        PutMem4 p + 20 + i * 4, Bounds(i)
    Next

End Function

Public Function DestroySAFEARRAY(ByVal ppArray As Long) As Long
    Dim p As Long
    GetMem4 ppArray, VarPtr(p)
    SafeArrayDestroyDescriptor ByVal p
    PutMem4 ppArray, 0
End Function

Public Function RedimArray(ByVal DataSize As eDATASIZE, _
                           ByVal lNumElements As Long, _
                           ByRef sa As SAFEARRAYHEADER, _
                           ByVal lDataPointer As Long, _
                           ByVal lArrayPointer As Long, _
                           Optional LoBound As Long = 0) As Long

    If lNumElements > 0 And lDataPointer > 0 And lArrayPointer > 0 Then
        ''''    Dim lZero&
  
        sa.DataSize = DataSize                            ' byte = 1 byte, integer = 2 bytes etc
        sa.dimensions = 1                                 ' one dimensional
        sa.dataPointer = lDataPointer                     ' to unicode string data (or other?)
        sa.sab(0).lLbound = LoBound                       ' lower bound
        sa.sab(0).cElements = lNumElements                ' number of elements
        RtlMoveMemory ByVal lArrayPointer, VarPtr(sa), 4& ' fake VB out
        RedimArray = True
    End If

End Function

Public Sub DestroyArray(ByVal lArrayPointer As Long)
    Dim lZero&
  
    RtlMoveMemory ByVal lArrayPointer, lZero, 4
End Sub

'_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
'                                 modConv
'_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
Public Function HexDecode(Text As String) As String
    Dim i As Long
    Dim s As String
    Dim b() As Byte
    Dim lArrayPointer As Long
    Dim sa As SAFEARRAYHEADER
    Dim StrLen As Long
    Dim j As Long
    s = Space$(Len(Text) / 4)
    j = 1
    lArrayPointer = VarPtrArray(b)                      '

    If RedimArray(byteArray, LenB(s), sa, StrPtr(s), lArrayPointer) = True Then
        StrLen = LenB(s) - 1

        For i = 0 To StrLen
            b(i) = CByte("&h" & Mid$(Text, j, 2))
            j = j + 2
        Next

        DestroyArray lArrayPointer
    End If

    HexDecode = s
    
End Function

Public Function HexEncode(Text As String) As String
    Dim i As Long
    Dim s As String
    Dim b() As Byte
    Dim lArrayPointer As Long
    Dim sa As SAFEARRAYHEADER
    Dim Sim As String
    Dim StrLen As Long
    s = Text
    lArrayPointer = VarPtrArray(b)

    If RedimArray(byteArray, LenB(s), sa, StrPtr(s), lArrayPointer) = True Then
        StrLen = LenB(s) - 1

        For i = 0 To StrLen
            Sim = Hex$(b(i))

            If Len(Sim) = 1 Then Sim = "0" & Sim
            HexEncode = HexEncode & Sim
        Next

        DestroyArray lArrayPointer
    End If

End Function

