Attribute VB_Name = "modOpenFile"

'        "Visual Basic 4 -  "
'       Flags   "  
'    Windows 3.1", PC Magazine,  4, 1992, . 89-96

Private Type TOpenFileName
    lStructSize As Long          '     
                                 ' ( Windows   )
    hwndOwner As Long            '  - .  
                                 ' ,    Flags    cdlOFNFileShowHelp
    hInstance As Long            '   ,  
                                 '  . ,    Flags
                                 '    OFN_EnableTemplate  OFN_EnableTemplateHandle
    lpstrFilter As String        '     .
                                 '    -   ( -  ),
                                 '   -   ( - "*.TXT)
    lpstrCustomFilter As String  '      
                                 '  
    nMaxCustFilter As Long       '   lpstrCustomFilter
    nFilterIndex As Long         '  ,   
                                 '       .   1.
    lpstrFile As String          ' ,     
                                 '      (   ).
                                 '        ,
                                 '  
    nMaxFile As Long             '  ,    lpstrFile
    lpstrFileTitle As String     ' ,      
                                 ' ,   (    ).
    nMaxFileTitle As Long        '  ,    lpstrFileTitle
    lpstrInitialDir As String    '   ,   .
    lpstrTitle As String         ' ,    .
    Flags As Long                '    .
    nFileOffset As Integer       '       ,
                                 '    lpstrFile (  )
    nFileExtension As Integer    '        ,
                                 '    lpstrFile
    lpstrDefExt As String        ' ,      ,  
                                 '   .
    lCustData As Long            '  (  )
    lpfnHook As Long             '  (  )
    lpTemplateName As String     ' ,       
                                 '  .     Flags  
                                 '  OFN_EnableTemplate
End Type

Private Declare Function GetOpenFileName Lib "COMDLG32" Alias "GetOpenFileNameA" _
    (file As TOpenFileName) As Long

'   Flags  TOpenFileName
Public Const OFN_ReadOnly = &H1               '      
                                              '   ReadOnly.
Public Const OFN_OverwritePrompt = &H2        '   ' '  
                                              '    
                                              '    .
Public Const OFN_HideReadOnly = &H4           '      ReadOnly
                                              '   .
Public Const OFN_NoChangeDir = &H8            '      ,
                                              '      .
Public Const OFN_FileShowHelp = &H10          '      Help
                                              '      
                                              '  ,    
                                              ' ,   ,  
                                              '      .
Public Const OFN_EnableHook = &H20
Public Const OFN_EnableTemplate = &H40
Public Const OFN_EnableTemplateHandle = &H80
Public Const OFN_NoValidate = &H100           ' ,     
                                              '    ,  .
Public Const OFN_AllowMultiselect = &H200     ' ,      
                                              '    .
Public Const OFN_ExtensionDifferent = &H400   ' ,     
                                              '   lpstrDefExt
Public Const OFN_PathMustExist = &H800        ' ,      
                                              '   .
Public Const OFN_FileMustExist = &H1000       ' ,    
                                              '      .
Public Const OFN_CreatePrompt = &H2000        '      
                                              '   .
Public Const OFN_ShareAware = &H4000          ' ,  ,   
                                              '  ,  .
Public Const OFN_NoReadOnlyReturn = &H8000    ' ,  ,    
                                              '   ReadOnly    
                                              ' "  ".
Public Const OFN_NoTestFileCreate = &H10000   ' ,       
                                              '   .
Public Const OFN_NoNetworkButton = &H20000
Public Const OFN_NoLongNames = &H40000        ' force no long names for 4.x modules
' Win95 only
Public Const OFN_Explorer = &H80000
Public Const OFN_NodeRefenceLinks = &H100000
Public Const OFN_Longnames = &H200000

Public Const cMaxPath = 260
Public Const cMaxFile = 260

Private Function StrZToStr(s As String) As String
    StrZToStr = Left$(s, InStr(s, vbNullChar) - 1)
End Function

Public Function vbaGetOpenFileName(vFileName As Variant, _
                           Optional vFileTitle As Variant, _
                           Optional vFlags As Variant, _
                           Optional vOwner As Variant, _
                           Optional vFilter As Variant, _
                           Optional vFilterIndex As Variant, _
                           Optional vInitDir As Variant, _
                           Optional vTitle As Variant, _
                           Optional vDefExt As Variant) As Boolean
            
Dim opfile As TOpenFileName, s As String

With opfile
    .lStructSize = Len(opfile)
    ' vFileName    ,   
    ' vFileTitle    ,   
    If IsMissing(vFileTitle) Then vFileTitle = vbNullString
    ' vFlags        
    If IsMissing(vFlags) Then vFlags = OFN_NoChangeDir + OFN_PathMustExist + OFN_FileMustExist
    ' vFilter    -,   |
    If IsMissing(vFilter) Then vFilter = "  (*.*)| *.*"
    ' vFilterIndex      (  1)
    If IsMissing(vFilterIndex) Then vFilterIndex = 1
    ' vOwner    -
    If Not IsMissing(vOwner) Then .hwndOwner = vOwner
    ' vInitDir     
    If Not IsMissing(vInitDir) Then .lpstrInitialDir = vInitDir
    ' vDefExt     
    If Not IsMissing(vDefExt) Then .lpstrDefExt = vDefExt
    ' vTitle     
    If Not IsMissing(vTitle) Then .lpstrTitle = vTitle
    
    '      Windows,   "|" 
    Dim ch As String, i As Integer
    For i = 1 To Len(vFilter)
        ch = Mid$(vFilter, i, 1)
        If ch = "|" Then
            s = s & vbNullChar
        Else
            s = s & ch
        End If
    Next
    '     
    s = s & vbNullChar & vbNullChar
    .lpstrFilter = s
    .nFilterIndex = vFilterIndex
    
    '         
    s = vFileName & String$(cMaxPath - Len(vFileName), 0)
    .lpstrFile = s
    .nMaxFile = cMaxPath
    s = vFileTitle & String$(cMaxFile - Len(vFileTitle), 0)
    .lpstrFileTitle = s
    .nMaxFileTitle = cMaxFile
    
    '  ,     Visual Basic
    .Flags = vFlags And &H1FF1F

    If GetOpenFileName(opfile) Then
        vbaGetOpenFileName = True
        vFileName = StrZToStr(.lpstrFile)
        vFileTitle = StrZToStr(.lpstrFileTitle)
        vFlags = .Flags
    Else
        vbaGetOpenFileName = False
        vFileName = ""
        vFileTitle = ""
        vFlags = 0
    End If
End With
End Function



